"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("./types");
function cast(val, type) {
    let valueType = types_1.Types.getTypesOf(val);
    if (type === 'boolean')
        return !!val;
    if (type === 'number') {
        if (types_1.Types.primitive(val)) {
            val = +val;
            if (isNaN(val))
                throw "can't cast NaN to number!";
            return val;
        }
        else {
            throw `can't cast non primitive value to number!`;
        }
    }
    if (type === 'string') {
        if (types_1.Types.primitive(val) || types_1.Types.date(val) || types_1.Types.regexp(val) || types_1.Types.function(val))
            return "" + val;
        else if (types_1.Types.object(val) || Array.isArray(val))
            return JSON.stringify(val);
    }
    if (type === 'date') {
        if (types_1.Types.number(val) || types_1.Types.string(val)) {
            let d = new Date(val);
            if (d.toString() === "Invalid Date")
                throw "can't cast value to a date!";
            return d;
        }
        if (types_1.Types.date(val))
            return val;
        throw "can't cast value to a date!";
    }
    if (type === "regexp") {
        if (types_1.Types.primitive(val))
            return new RegExp(val);
        if (types_1.Types.regexp(val))
            return val;
        throw "can't cast value to a regexp!";
    }
    if (type === 'array')
        return Array.isArray(val) ? val : [val];
    throw `unsupported type ${type}`;
}
exports.cast = cast;
//# sourceMappingURL=cast.js.map