"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BinarySearchTeeeNode {
    constructor(val) {
        this.val = val;
    }
}
exports.BinarySearchTeeeNode = BinarySearchTeeeNode;
class BinarySearchTeee {
    constructor(comparer = null) {
        this.comparer = comparer;
    }
    compare(a, b) {
        return this.comparer ? this.comparer(a, b) : (a - b);
    }
    insert(val) {
        let newNode = new BinarySearchTeeeNode(val);
        if (!this.root) {
            this.root = newNode;
            return this;
        }
        let curr = this.root;
        while (true) {
            let compare = this.compare(curr.val, val);
            if (compare > 0) {
                if (curr.right) {
                    curr = curr.right;
                }
                else {
                    curr.right = newNode;
                    break;
                }
            }
            else if (compare < 0) {
                if (curr.left) {
                    curr = curr.left;
                }
                else {
                    curr.left = newNode;
                    break;
                }
            }
            else {
                break;
            }
        }
        return this;
    }
    find(val) {
        let curr = this.root;
        while (curr) {
            let compare = this.compare(curr.val, val);
            if (compare === 0)
                return curr.val;
            if (compare > 0)
                curr = curr.right;
            if (compare < 0)
                curr = curr.left;
        }
        return null;
    }
    PFS() {
        if (!this.root)
            return [];
        let queue = [this.root];
        let visisted = [];
        let curr;
        while (queue.length > 0) {
            curr = queue.shift();
            visisted.push(curr.val);
            if (curr.left)
                queue.push(curr.left);
            if (curr.right)
                queue.push(curr.right);
        }
        return visisted;
    }
    DFS(order) {
        let visited = [];
        if (!this.root)
            return [];
        function travers(node) {
            order < 0 && visited.push(node.val);
            if (node.left)
                travers(node.left);
            order === 0 && visited.push(node.val);
            if (node.right)
                travers(node.right);
            order > 0 && visited.push(node.val);
        }
        travers(this.root);
        return visited;
    }
    DFSPreOrder() {
        let visited = [];
        if (!this.root)
            return [];
        function travers(node) {
            visited.push(node.val);
            if (node.left)
                travers(node.left);
            if (node.right)
                travers(node.right);
        }
        travers(this.root);
        return visited;
    }
    DFSPostOrder() {
        let visited = [];
        if (!this.root)
            return [];
        function travers(node) {
            if (node.left)
                travers(node.left);
            if (node.right)
                travers(node.right);
            visited.push(node.val);
        }
        travers(this.root);
        return visited;
    }
    DFSInOrder() {
        let visited = [];
        if (!this.root)
            return [];
        function travers(node) {
            if (node.left)
                travers(node.left);
            visited.push(node.val);
            if (node.right)
                travers(node.right);
        }
        travers(this.root);
        return visited;
    }
}
exports.BinarySearchTeee = BinarySearchTeee;
//# sourceMappingURL=binary-search-tree.js.map