export declare class DoublyLinkedListNode<T> {
    val: T;
    next: DoublyLinkedListNode<T>;
    prev: DoublyLinkedListNode<T>;
    constructor(val: T);
}
export declare class DoublyLinkedList<T = number> {
    head: DoublyLinkedListNode<T>;
    tail: DoublyLinkedListNode<T>;
    length: number;
    constructor(...args: T[]);
    get(pos: number): DoublyLinkedListNode<T>;
    indexOf(val: T): number;
    includes(cb: (val: T) => boolean): boolean;
    find(cb: (val: T) => boolean): DoublyLinkedListNode<T>;
    findIndex(cb: (val: T) => boolean): number;
    set(pos: number, val: T): this;
    push(val: T): this;
    pop(): T;
    unshift(val: T): this;
    shift(): T;
    insert(pos: number, val: T): this;
    remove(pos: number): T;
    forEach(cb: (val: T, pos?: number) => void): void;
    filter(cb: (val: T, pos?: number) => boolean): DoublyLinkedList<T>;
    map<U = T>(cb: (val: T, pos?: number) => U): DoublyLinkedList<U>;
    reduce(cb: (prev: any, curr: T) => any, start: any): any;
    slice(start?: number, end?: number): DoublyLinkedList<T>;
    splice(start?: number, deleteCount?: number, ...replace: T[]): void;
    toArray(): T[];
    reverse(): this;
    toString(): string;
}
