export declare class LinkedListNode<T> {
    val: T;
    next: LinkedListNode<T>;
    constructor(val: T);
}
export declare class LinkedList<T = number> {
    head: LinkedListNode<T>;
    tail: LinkedListNode<T>;
    length: number;
    constructor(...args: T[]);
    get(pos: number): LinkedListNode<T>;
    indexOf(val: T): number;
    includes(cb: (val: T) => boolean): boolean;
    find(cb: (val: T) => boolean): LinkedListNode<T>;
    findIndex(cb: (val: T) => boolean): number;
    set(pos: number, val: T): this;
    push(val: T): this;
    pop(): T;
    unshift(val: T): this;
    shift(): LinkedListNode<T>;
    insert(pos: number, val: T): this;
    remove(pos: number): T | LinkedListNode<T>;
    forEach(cb: (val: T, pos?: number) => void): void;
    filter(cb: (val: T, pos?: number) => boolean): LinkedList<T>;
    map<U = T>(cb: (val: T, pos?: number) => U): LinkedList<U>;
    reduce(cb: (prev: any, curr: T) => any, start: any): any;
    slice(start?: number, end?: number): LinkedList<T>;
    splice(start?: number, deleteCount?: number, ...replace: T[]): LinkedList<T>;
    toArray(): T[];
    reverse(): this;
    toString(): string;
}
