"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class QueueNode {
    constructor(val) {
        this.val = val;
    }
}
exports.QueueNode = QueueNode;
class Queue {
    constructor(max = -1) {
        this.max = max;
        this.length = 0;
    }
    push(val) {
        if (this.length === this.max)
            return;
        let newNode = new QueueNode(val);
        if (this.length === 0) {
            this.first = this.last = newNode;
        }
        else {
            this.last.next = newNode;
            this.last = newNode;
        }
        this.length++;
        return this;
    }
    pop() {
        if (this.length === 0)
            return null;
        let popped = this.first;
        this.first = popped.next;
        this.length--;
        return popped.val;
    }
    clear() {
        this.first = this.last = null;
        this.length = 0;
        return this;
    }
}
exports.Queue = Queue;
//# sourceMappingURL=queue.js.map