"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class StackNode {
    constructor(val) {
        this.val = val;
    }
}
exports.StackNode = StackNode;
class Stack {
    constructor(max = -1) {
        this.max = max;
        this.length = 0;
    }
    push(val) {
        if (this.length === this.max)
            return this;
        let newNode = new StackNode(val);
        newNode.prev = this.last;
        this.last = newNode;
        this.length++;
        return this;
    }
    pop() {
        if (!this.last)
            return null;
        let popped = this.last;
        this.last = popped.prev;
        this.length--;
        return popped.val;
    }
    clear() {
        this.last = null;
        this.length = 0;
        return this;
    }
}
exports.Stack = Stack;
//# sourceMappingURL=stack.js.map