export interface IFetchOptions {
    url: string;
    method?: 'HEAD' | 'GET' | 'POST' | 'PUT' | 'PATCH' | 'DELETE';
    headers?: {
        [keys: string]: string | number;
    };
    data?: {
        [key: string]: any;
    };
    wait?: boolean;
    timeout?: number;
}
export default function fetch(options: IFetchOptions): Promise<{
    statusCode: number;
    data: any;
}>;
