"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("./types");
exports.Is = {
    value(val) { return (typeof val === 'string' && !!val.trim()) || (val !== undefined && val !== null); },
    notEmpty(val) { return (Array.isArray(val) && !!val.length) || (typeof val === 'string' && !!val.trim().length) || (types_1.Types.object(val) && !!Object.keys(val).length); },
    number(val) { return !isNaN(+val); },
    name(val) { return /^[A-Z][a-z]+(\s[A-Z][a-z]+)*$/g.test(val); },
    email(val) { return /^([\w\-]+(?:\.[\w\-]+)*)@((?:[\w\-]+\.)*\w[\w\-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i.test(val); },
    url(val) { return /(?:(?:https?|ftp|file):\/\/|www\.|ftp\.)(?:\([-A-Z0-9+&@#\/%=~_|$?!:,.]*\)|[-A-Z0-9+&@#\/%=~_|$?!:,.])*(?:\([-A-Z0-9+&@#\/%=~_|$?!:,.]*\)|[-A-Z0-9+&@#\/%=~_|$])/igm.test(val); },
    date(val) {
        if (types_1.Types.date(val))
            return true;
        if (types_1.Types.string(val) || types_1.Types.number(val)) {
            let d = new Date(val);
            if (d.toString() === "Invalid Date")
                return false;
            return true;
        }
        return false;
    }
};
//# sourceMappingURL=is.js.map