"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getOwnPropList(src, propName, path) {
    let result = {};
    if (!src)
        return null;
    if (typeof src === "object") {
        if (src.hasOwnProperty(propName))
            result[path ? path + propName : propName] = src[propName];
        if (Array.isArray(src)) {
            for (let i = 0; i < src.length; i++) {
                if (typeof src[i] === "object") {
                    let currPath = path ? `${path}[${i}]` : `[${i}]`;
                    let subResults = getOwnPropList(src[i], propName, currPath);
                    if (subResults && Object.keys(subResults).length)
                        Object.assign(result, subResults);
                }
            }
        }
        else {
            for (let prop in src) {
                if (typeof src[prop] === "object") {
                    let currPath = path ? `${path}.${prop}` : prop;
                    let subResults = getOwnPropList(src[prop], propName, currPath);
                    if (subResults && Object.keys(subResults).length)
                        Object.assign(result, subResults);
                }
            }
        }
    }
    return Object.keys(result).length ? result : null;
}
exports.getOwnPropList = getOwnPropList;
//# sourceMappingURL=get-own-prop-list.js.map