"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const clean_prop_path_1 = require("./clean-prop-path");
function valuefromPath(src, path, newValue, inject) {
    if (typeof src !== "object")
        return undefined;
    let parts = clean_prop_path_1.cleanPropPath(path).split('.');
    let currentField = parts.shift();
    if (currentField === '$') {
        if (!Array.isArray(src))
            return;
        return handleAnonymousArrayIndex(src, parts.join('.'), newValue, inject);
    }
    if (parts.length === 0) {
        if (newValue === undefined) {
            return src[path];
        }
        else if (inject || src.hasOwnProperty(path)) {
            if (typeof newValue === "function")
                return src[path] = newValue(src[path]);
            else
                return src[path] = newValue;
        }
        else {
            return undefined;
        }
    }
    if (src[currentField] === undefined)
        if (inject && parts[0] !== '$')
            src[currentField] = !isNaN(Number(parts[0])) ? [] : {};
        else
            return undefined;
    if (Array.isArray(src[currentField])) {
        if (parts[0] === '$') {
            return handleAnonymousArrayIndex(src[currentField], parts.slice(1).join('.'), newValue, inject);
        }
        if (src[currentField].length === 0 && inject && parts.length > 1)
            src[currentField][0] = {};
        if (parts.length === 1)
            return valuefromPath(src[currentField], parts[0], newValue, inject);
        if (!isNaN(Number(parts[0])))
            return valuefromPath(src[currentField][Number(parts[0])], parts.slice(1).join('.'), newValue, inject);
    }
    return valuefromPath(src[currentField], parts.join('.'), newValue, inject);
}
exports.valuefromPath = valuefromPath;
function handleAnonymousArrayIndex(src, path, newValue, inject) {
    let result = [];
    for (let i = 0; i < src.length; i++) {
        if (!path) {
            if (newValue)
                src[i] = newValue;
            result.push(src[i]);
        }
        else {
            let val = valuefromPath(src[i], path, newValue, inject);
            if (val)
                result.push(val);
        }
    }
    return result;
}
//# sourceMappingURL=value-from-path.js.map