"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
let map = { y: 217728000, m: 18144000, w: 604800, d: 86400, h: 3600, i: 60, s: 1 };
function parseTime(timeStr) {
    let time = 0;
    let parts = timeStr.split(' ');
    parts.forEach(function (part) {
        if (!part.length)
            return time += 0;
        let amount = part.slice(0, -1), unit = part.slice(-1);
        if (map.hasOwnProperty(unit))
            time += map[unit] * parseInt(amount, 10);
    });
    return time * 1000;
}
exports.parseTime = parseTime;
//# sourceMappingURL=parse-time.js.map