/// <reference types="@types/node" />
import { URL as RootURL } from 'url';
export declare class PathPattern {
    private _parts;
    private _pattern;
    private _params;
    private _outputParams;
    private _hasRest;
    private _hasOptional;
    constructor(pattern: string);
    static Clean(path: string): string;
    private init;
    readonly params: string[];
    pattern: string;
    match(path: string): boolean;
    getParamsObj(path: string): {
        [key: string]: string;
    };
    pathFromParamsObj(paramsObj: {
        [key: string]: string | number;
    }): string;
}
export declare class URL extends RootURL {
    queryObject: any;
    private _pathPattern;
    private _paramsObj;
    constructor(href: string, base?: string | RootURL);
    static QueryToObject(query: string): any;
    static ObjectToQuery(obj: {
        [key: string]: any;
    }, encode?: boolean): string;
    static Clean(path: string): string;
    static From(origin: string, pathname?: {
        pattern: string;
        params?: {
            [key: string]: string;
        };
    } | string, searchObj?: any, hash?: string): URL;
    pathname: string;
    pathPattern: string;
    pathParmsObj: {
        [key: string]: string | number;
    };
    setPathParam(key: string, value: string | number): void;
    isSecure(): boolean;
    secure(enable?: boolean): void;
}
